declare class TokenParser {
    private readonly token;
    constructor(token: Token);
    readonly parseVersion: () => {
        readonly exists: false;
        readonly type?: undefined;
        readonly value?: undefined;
    } | {
        readonly type: "version";
        readonly exists: true;
        readonly value: "1.5.7";
    };
    readonly parseHelp: () => {
        readonly exists: false;
        readonly type?: undefined;
        readonly value?: undefined;
    } | {
        readonly type: "help";
        readonly exists: true;
        readonly value: string;
    };
    readonly parseDir: () => {
        readonly exists: false;
        readonly type?: undefined;
        readonly value?: undefined;
    } | {
        readonly type: "dir";
        readonly exists: true;
        readonly value: string;
    };
    readonly parseInclude: () => {
        readonly exists: false;
        readonly type?: undefined;
        readonly value?: undefined;
    } | {
        readonly type: "include";
        readonly exists: true;
        readonly value: string[];
    };
    readonly parseShowChanges: () => {
        readonly exists: false;
        readonly type?: undefined;
        readonly value?: undefined;
    } | {
        readonly type: "showchanges";
        readonly exists: true;
        readonly value: boolean;
    };
    readonly processNonRecognisableToken: () => {
        readonly type: "invalid";
        readonly reason: "then token cannot be recognized";
        readonly token: Readonly<{
            key: string;
            value: string;
        }>;
    };
}
type Token = Readonly<{
    key: string;
    value: string;
}>;
export default class ParseArgs {
    private readonly tokens;
    private constructor();
    static readonly create: (arg: string) => ParseArgs;
    private static readonly checkPackageName;
    private readonly tokenize;
    readonly asVersion: () => {
        readonly exists: false;
        readonly type?: undefined;
        readonly value?: undefined;
    } | {
        readonly type: "version";
        readonly exists: true;
        readonly value: "1.5.7";
    };
    readonly asHelp: () => ReturnType<TokenParser['parseHelp']>;
    readonly asOperation: () => {
        readonly dir: string;
        readonly include: string[] | undefined;
        readonly showChanges: boolean | undefined;
    };
}
type TrueConfig = ReturnType<ParseArgs['asOperation']>;
type PartialConfig = Partial<Omit<TrueConfig, 'dir'>> & Pick<TrueConfig, 'dir'>;
export type { TrueConfig, PartialConfig };
