"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tsAddJsExtension = exports.parseConfig = void 0;
var read_write_1 = __importDefault(require("./read-write"));
var cli_command_parser_1 = __importDefault(require("./cli-command-parser"));
var config_1 = require("./config");
Object.defineProperty(exports, "parseConfig", { enumerable: true, get: function () { return config_1.parseConfig; } });
var tsAddJsExtension = function (_a) {
    var config = _a.config, parsedConfigFunction = _a.parsedConfigFunction;
    return __awaiter(void 0, void 0, void 0, function () {
        var trueConfig, file, _b, _c;
        var _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (parsedConfigFunction) {
                        throw new Error([
                            "Please do not use parsedConfigFunction as it's deprecated and contains complicated parsing",
                            "Instead, just pass configurations directly",
                        ].join('\n'));
                    }
                    trueConfig = (0, config_1.valuelizeConfig)(config);
                    file = read_write_1.default.create();
                    _c = (_b = file).writeMany;
                    _d = {
                        showChanges: trueConfig.showChanges
                    };
                    return [4 /*yield*/, file.findMany(trueConfig)];
                case 1: return [2 /*return*/, _c.apply(_b, [(_d.withJSExtension = _e.sent(),
                            _d)])];
            }
        });
    });
};
exports.tsAddJsExtension = tsAddJsExtension;
var main = function (args) {
    var parser = cli_command_parser_1.default.create(args);
    var help = parser.asHelp();
    if (help.exists) {
        return console.log(help.value);
    }
    var version = parser.asVersion();
    if (version.exists) {
        return console.log(version.value);
    }
    return tsAddJsExtension({
        config: parser.asOperation(),
    })
        .then(function (result) {
        switch (result.type) {
            case 'error': {
                console.error(result.error);
            }
        }
    })
        .catch(console.error);
};
exports.default = main;
//# sourceMappingURL=index.js.map