import ts from 'typescript';
import type { PartialConfig } from './cli-command-parser';
import traverseAndUpdateFileWithJSExtension from './traverse-and-update';
type SourceFile = Awaited<ReturnType<typeof getAllJSAndDTSCodes>[0]>;
type Files = ReadonlyArray<string>;
declare const getAllJSAndDTSCodes: (files: Files) => Promise<ts.SourceFile>[];
export default class File {
    private constructor();
    static readonly create: () => File;
    readonly findMany: ({ dir, include, }: Readonly<{
        dir: PartialConfig['dir'];
        include: ReadonlyArray<string>;
    }>) => Promise<{
        file: string;
        code: string;
    }[]>;
    readonly writeMany: ({ showChanges, withJSExtension, }: Readonly<{
        showChanges: boolean;
        withJSExtension: ReturnType<ReturnType<typeof traverseAndUpdateFileWithJSExtension>>;
    }>) => Promise<{
        readonly type: "done";
        readonly error?: undefined;
    } | {
        readonly type: "error";
        readonly error: unknown;
    }>;
}
export type { SourceFile, Files };
